package demojavadoc; // make a directory called demojavadoc and put JavadocDemo.java in it

/**
* Demonstrate the use of javadoc and where to put the comments, which is directly above the class or class member you are writing about
* @author Thomas Albert of Night Classes
* @version 1.1
*/
public class JavadocDemo {  // my custom exception
   /**
   * Drives the program and contains the try/catch * blocks
   * @param args an array of Strings typed at the command-line
   */
   public static void main(String[] args) 
   {
      int size;      
      for(size = 3; size > -3; size--)
      {

         try 
         {
            System.out.println("in try block");
            System.out.println("size = " + size);
            if (size == -1)
            {  
               // call the default constructor
               // of the Exception subclass
               // when throwing
               throw new ThomasException(1,2);
            }
            int myArray[] = new int[size];
            System.out.println("length is: " + myArray.length);
         }
         catch (ThomasException e)
         {
             System.out.println("in catch block1");
             System.out.println("ThomasException is " + e.toString());
             e.printStackTrace();
         } 
         catch (NegativeArraySizeException  e)
         {
            System.out.println("in catch block2");
            System.out.println("Negative array " + e.toString());
            System.out.println("print stack trace next");
            e.printStackTrace();
         }
         finally
         {
            System.out.println("we are in the finally block, which gets executed whether or not an exception is thrown. A valid use case is to close a database exception when we are done using it.");
         }
                
      } // end for  
   } // end main
   /**
   * @deprecated use main instead
   * @return an int
   */
   public int unused()
   {
      return 5;
   }   
}   